//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window

extern int    StepPips       = 50;
extern int    AddPips        = 15;
extern bool   showLines      = true;
extern bool   showPrices     = false;
extern int    pricesShift    = 5;
extern color  linesColor     = DimGray;
extern int    linesStyle     = STYLE_SOLID;
extern color  addLinesColor  = DimGray;
extern int    addLinesStyle  = STYLE_DOT;
extern color  pricesColor    = DimGray;
extern string UniqueID       = "PriceGrid1";

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   return(0);
}
int deinit()
{
   int lookForLength = StringLen(UniqueID);
   for (int i=ObjectsTotal()-1; i>=0; i--) 
   {
      string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == UniqueID) ObjectDelete(name);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   static datetime last  = 0;
   static datetime first = 0;
   
   //
   //
   //
   //
   //
         
   if (first != Time[Bars-1] || last != Time[0])
   {
      double pipMultiplier = 1; if (Digits==3 || Digits==5) pipMultiplier = 10;
      double lowPrice  = Low[ iLowest (NULL,0,MODE_LOW ,0,0)];
      double highPrice = High[iHighest(NULL,0,MODE_HIGH,0,0)];
      double diff      = (StepPips*pipMultiplier*Point);
      double add       = (AddPips *pipMultiplier*Point);
      double low       = MathFloor(lowPrice/diff)*diff;
      double high      = MathCeil(highPrice/diff)*diff;
      double current   = low;
             first     = Time[Bars-1];
             last      = Time[0];
         
      //
      //
      //
      //
      //
         
         int lookForLength = StringLen(UniqueID);
         for (int k=ObjectsTotal()-1; k>=0; k--) 
         {
            string name = ObjectName(k);  if (StringSubstr(name,0,lookForLength) == UniqueID) ObjectDelete(name);
         }

         //
         //
         //
         //
         //
         
         int totalLevels = 0;
         while(current<=high)
         {
            if (showLines)               { drawLine(totalLevels,current    ,linesColor   ,linesStyle   );  drawLine(totalLevels,current+diff,linesColor   ,linesStyle   ); }
            if (add>0)                   { drawLine(totalLevels,current+add,addLinesColor,addLinesStyle);  drawLine(totalLevels,current-add ,addLinesColor,addLinesStyle); }
            if (showPrices && showLines) { drawPrice(totalLevels,current); drawPrice(totalLevels,current+diff); }
                  
            //
            //
            //
            //
            //
                              
            current += (diff*2);
         }
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawLine(int& totalLevels, double current, color theColor, int theStyle)
{
   totalLevels++; string name = UniqueID+":"+totalLevels;
   
      ObjectCreate(name,OBJ_TREND,0,Time[Bars-1],current,Time[0],current);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,theStyle);
         ObjectSet(name,OBJPROP_BACK,true);

}
void drawPrice(int& totalLevels, double current)
{
   totalLevels++; string name = UniqueID+":"+totalLevels;
      ObjectCreate(name,OBJ_TEXT,0,barTime(-pricesShift),current);
         ObjectSet(name,OBJPROP_COLOR,pricesColor);
         ObjectSet(name,OBJPROP_BACK,true);
     ObjectSetText(name,DoubleToStr(current,Digits),10,"Arial",pricesColor);
}     

//
//
//
//
//

int barTime(int a)
{
   if(a<0)
         return(Time[0]+Period()*60*MathAbs(a));
   else  return(Time[a]);   
}